/*======================================================================*
 *		        						* 
 * TITLE:	MYACC -- LALR(1) parser generator for modula-2	        *
 *									*
 * FILE:	filegen.c - output file generation module 		*
 * 					        			* 
 * UPDATED:     July 5, 1987						*
 *								        *
 * AUTHOR: 	Werner Stanglow						*
 *								        *
 *======================================================================*/

#include "mdefs.h"
#include "search.h"


#define BEAUTY "/u/bin/m2b"
/* External ===========================================================	*/
extern char eflag, bflag, lflag, tflag;	/* flags from command line 	*/ 


/* Exported =========================================================== */

genimports()

{	
	fprintf(fm2,"\nIMPORT StdIO, F, S, Strings ");
	if (lflag)
		fprintf(fm2,", SYSTEM");
	if (*initmodule)
		fprintf(fm2,", %s",initmodule);	
	fprintf(fm2,";\n");
}

initfiles(name,beauty) 

char *name;
int beauty;

{	char cmd[128];

	sprintf(cmd,"%s >%s ",BEAUTY,FM2);
	if (beauty)
	{	if (!(fm2 = popen(cmd,"w"))) 
		{	error("cannot open beautifier\n");
		 	ffopen(fm2,FM2,"w");
		}
	}
        else
		ffopen(fm2,FM2,"w");
	fprintf(fm2,"IMPLEMENTATION MODULE %s;\n",MODULE);
	fprintf(fm2,"\n(*\n * generated by: %s\n * from:         %s\n *)\n",
		VERSION,name);
	if(*FOUT)
	{	ffopen(fout,FOUT,"w");
		fprintf(fout,
			"(*\n * generated by: %s\n * from:         %s\n *)\n",
			VERSION,name);
	}
	sprintf(cmd,"%s 1>%s ",BEAUTY,FDEF);
	if (beauty)
	{	if (!(fdef = popen(cmd,"w"))) 
		{	error("cannot open beautifier\n");
		 	ffopen(fdef,FDEF,"w");
		}
	}
        else
		ffopen(fdef,FDEF,"w");
	fprintf(fdef,"DEFINITION MODULE %s;\n",MODULE);	
	fprintf(fdef,
		"\n(*\n * generated by: %s\n * from:         %s\n *)\n",
		VERSION,name);
}

/* --------------------------------------------------------------------	*/
closeupfiles(bflag)								
int bflag;
{
	fprintf(fm2,"END %s.\n",MODULE);
	fprintf(fdef,"END %s.\n",MODULE);
	if (fout)
		ffclose(fout);
	if (!bflag)
	{	ffclose(fm2);
		ffclose(fdef);
	}
	else
	{	int i;
		if (i=pclose(fm2))
			error(stderr,"beautifier (fm2 ) returns %d\n",i);
		if (i= pclose(fdef))
			error(stderr,"beautifier (fdef) returns %d\n",i);
	}
}


/* --------------------------------------------------------------------	*/
copyfile(source, dest, match, copy)

FILE *source, *dest;
char *match;
int copy;
{ 	register char *cp, *keep;
	register c;

	for(;;)
	{
		cp = keep = match;
		while (((c=getc(source)) != EOF) && (c != *cp))
			if (copy)
				putc(c,dest);
		if (c==EOF)
			return;
		while (*++cp && ((c=getc(source)) != EOF) && (c == *cp));
		if (*cp)		/* end of string not reached */
		{	while (keep < cp)
			{	if (copy)
					putc(*keep,dest);
				++keep;
			}
			if (copy) 
				putc(c,dest);		/* did not match */	
		}
		else
			return;
		if (c==EOF)
			return;
	}
}

/* --------------------------------------------------------------------	*/
genparser()			/* generate the complete parser from 	*/     
				/* the tempfiles			*/
{	char str[20];
	register i;
	extern char YyTabFile[];
	
	ffopen(fparser,FPARSER,"r");
	
	if (lflag)
		fprintf(fm2,"CONST\n   YyTabFile = \"%s\";\n",YyTabFile);

	copyfile(fparser,fdef,"$DEFEND",1);
  
	ffopen(flocal,FLOCAL, "r" );	 	/* insert constants */
	fprintf(fm2,"CONST\n");
	copyfile(flocal,fm2,"",1);
	ffclose(flocal);

	for(i=1; i<=6; ++i)			/* insert or skip debug code */	
	{	sprintf(str,"$IfDbg%d",i);
		copyfile(fparser,fm2,str,1);
		copyfile(fparser,fm2,"$EndIf",tflag);
	}

	copyfile(fparser,fm2,"$UserAction",1);

	ffopen(faction,FACTION,"r");
	copyfile(faction,fm2,"",1);
	ffclose(faction);

	copyfile(fparser,fm2,"$IfLoad1",1);
	copyfile(fparser,fm2,"$EndIf",lflag);
	copyfile(fparser,fm2,"$IfLoad2",1);
	copyfile(fparser,fm2,"$Stop",lflag);
	ffopen(fdata,FDATA,"r");
	copyfile(fdata,fm2,"",1);
	copyfile(fparser,fm2,"$EndIf",lflag);
	copyfile(fparser,fm2,"$IfInit",1);
	copyfile(fparser,fm2,"$InitProc",*initproc);
	if (*initproc)
		fprintf(fm2,"%s",initproc);
	copyfile(fparser,fm2,"",*initproc);
	ffclose(fparser);
}

/* -------------------------------------------------------------------- */
outtoken(tok,len,pos,val)	/* output a token definition for tok;	*/
char *tok;			/* len is the max. lenght of any token, */
int len, pos;			/* pos is the index in yytokens[]	*/
int val;			/* value of token			*/

{	static TABLE m2key[] =	{ 
#include "m2key.h"
				}; 	/* table of modula-2 keywords	*/
	
	if (!lflag)
		fprintf(fdata, "\t\%12s [%3d] := \"%s\";\n","yytokens",
			pos, tok);
	else
	{	register i, x = strlen(tok);
		for (i=0; i<x ; ++i)
			putc(tok[i],ftab);
		for (;x < len; ++x) 
			putc('\0',ftab);
	}
	if (!bsearch(tok,m2key,sizeof(m2key)/sizeof(m2key[0])))
		wdef(fdef,tok,val);
	else
	{	char buffer[100];
		strcpy( buffer,tok);
		strcat( buffer,"sy");
			wdef(fdef,buffer,val);
	}
}

expect()

{	if (!eflag)
	{	wdef(flocal,"yyexpectlast",0);
		return;
	}
	else /*eflag*/
	{       wdef(flocal,"yyexpectlast",nstate-1);
		if (!lflag)
		{	register i,j;
			SLOOP(i)
			{	char fst = 1;
			 	fprintf(fdata,"   yyexpect[%d] := ",i);
				fprintf(fdata,"yyexpectST {");
				TLOOP(j)
				 	if (Bit(i,j))
					{	if (fst)
						{	fprintf(fdata,"%d",j);
							fst = 0;
						}
						else
							fprintf(fdata,", %d",j);
					}
				fprintf(fdata,"};\n");
			}
		}
		else	/*lflag*/
		{	register i;
			fprintf(fdata, "AND yyread(SYSTEM.ADR(yyexpect),");
			fprintf(fdata,"SIZE(yyexpectST),yyexpectlast+1)\n");
			SLOOP(i)
				if (fwrite(Set(i),SetSz,1,ftab)!=1)
				    error("cannot write to %s (state = %d)",
						FTAB,i);
		}
	}
}
