/* 
 *  crude ....
 */

#ifndef	DEFS_H

#ifndef	GLOBAL
#define	GLOBAL	extern
#define	INIT(x)	/**/
#else
#define	INIT(x)	= x
#endif

#include <stdio.h>
#include <ctype.h>

#ifdef  SUN3
#define XELOS
#endif
#ifdef	XELOS				/* Concurrent System V */

#define SIGAVAI				
#define LASTSIG 19     	
				
#ifndef EOF
#define EOF (-1)
#endif

#define	WORD32

#ifndef	PARSER
#define PARSER "/usr/diplom1/stanglow/yyd/par/myaccpar" 
#endif

#define HUGETAB				/* table sizes */
#define FNAMESIZE 128			/* file name size */
#define EX_SUC 0			/* exits */
#define EX_WAR 1
#define EX_ERR 2
#define EX_SEV 4
#define EX_IRP 8			/* exit after interrupt */

#endif	/* ifdef XELOS */

#define YYEXCA 0
#define YYACT  1
#define YYPACT 2
#define YYPGO  3
#define YYR1   4
#define YYR2   5
#define YYRCHK 6
#define YYDEF  7
#define YYNOTAB 8

/*  MANIFEST CONSTANT DEFINITIONS */

/* base of nonterminal internal numbers */
#define NTBASE 010000

/* internal codes for error and accept actions */

#define ERRCODE  8190
#define ACCEPTCODE 8191

/* sizes and limits */

#ifdef HUGETAB
#define ACTSIZE 12000
#define MEMSIZE 12000
#define NSTATES 750
#define NTERMS 127
#define NPROD 600
#define NNONTERM 300
#define TEMPSIZE 1200
#define CNAMSZ 5000
#define LSETSIZE 600
#define WSETSIZE 350
#endif

#ifdef MEDTAB
#define ACTSIZE 4000
#define MEMSIZE 5200
#define NSTATES 600
#define NTERMS 127
#define NPROD 400
#define NNONTERM 200
#define TEMPSIZE 800
#define CNAMSZ 4000
#define LSETSIZE 450
#define WSETSIZE 250
#endif

#ifdef SMALLTAB
#define ACTSIZE 1000
#define MEMSIZE 1500
#define NSTATES 450
#define NTERMS 127
#define NPROD 200
#define NNONTERM 100
#define TEMPSIZE 600
#define CNAMSZ 1000
#define LSETSIZE 200
#define WSETSIZE 125
#endif

#define NAMESIZE 128
#define NTYPES 63

#ifdef WORD32
#define TBITSET ((32+NTERMS)/32)

/* bit packing macros (may be machine dependent) */
#define BIT(a,i) ((a)[(i)>>5] & (1<<((i)&037)))
#define SETBIT(a,i) ((a)[(i)>>5] |= (1<<((i)&037)))

/* number of words needed to hold n+1 bits */
#define NWORDS(n) (((n)+32)/32)

#else

#define TBITSET ((16+NTERMS)/16)

/* bit packing macros (may be machine dependent) */
#define BIT(a,i) ((a)[(i)>>4] & (1<<((i)&017)))
#define SETBIT(a,i) ((a)[(i)>>4] |= (1<<((i)&017)))

/* number of words needed to hold n+1 bits */
#define NWORDS(n) (((n)+16)/16)
#endif

/* relationships which must hold:
        TBITSET ints must hold NTERMS+1 bits...
        WSETSIZE >= NNONTERM
        LSETSIZE >= NNONTERM
        TEMPSIZE >= NTERMS + NNONTERMs + 1
        TEMPSIZE >= NSTATES
        */

/* associativities */

#define NOASC 0  /* no assoc. */
#define LASC 1  /* left assoc. */
#define RASC 2  /* right assoc. */
#define BASC 3  /* binary assoc. */

/* flags for state generation */

#define DONE 0
#define MUSTDO 1
#define MUSTLOOKAHEAD 2

/* flags for a rule having an action, and being reduced */

#define ACTFLAG 04
#define REDFLAG 010

/* output parser flags */
#define YYFLAG1 (-1000)

/* macros for getting associativity and precedence levels */

#define ASSOC(i) ((i)&03)

#define PLEVEL(i) (((i)>>4)&077)
#define TYPE(i)  ((i>>10)&077)

/* macros for setting associativity and precedence levels */

#define SETASC(i,j) i|=j
#define SETPLEV(i,j) i |= (j<<4)
#define SETTYPE(i,j) i |= (j<<10)


/* looping macros */

#define TLOOP(i) for(i=1;i<=ntokens;++i)
#define NTLOOP(i) for(i=0;i<=nnonter;++i)
#define PLOOP(s,i) for(i=s;i<nprod;++i)
#define SLOOP(i) for(i=0;i<nstate;++i)
#define WSBUMP(x) ++x
#define WSLOOP(s,j) for(j=s;j<cwp;++j)
#define ITMLOOP(i,p,q) q=pstate[i+1];for(p=pstate[i];p<q;++p)
#define SETLOOP(i) for(i=0;i<tbitset;++i)

/* structure declarations */

struct looksets
   {
   int lset[TBITSET];
   };

struct item
   {
   int *pitem;
   struct looksets *look;
   };

struct toksymb
   {
   char *name;
   int value;
   char iskey;
   };

struct ntsymb
   {
   char *name;
   int tvalue;
   };

struct wset
   {
   int *pitem;
   int flag;
   struct looksets ws;
   };

/* define functions with strange types... */

extern struct looksets *flset();
extern char *symnam();
extern char *writem();

/* default settings for a number of macros */

#define ISIZE 400       /* Specific for static in cpres() */


/* default output file names and suffixes */

#ifndef DEFNAME
#define DEFNAME "Myacc" 
#endif

#ifndef M2
#define M2 ".m2"
#endif  

#ifndef DEF
#define DEF ".d"
#endif

#ifndef VERBOSE
#define VERBOSE ".out"
#endif


/* temp file names */
#ifndef ACT
#define ACT ".act"
#endif

#ifndef DAT
#define DAT ".dat"
#endif

#ifndef TAB
#define TAB ".t"  
#endif
 
#ifndef LOC
#define LOC ".loc"
#endif

#ifndef TMP  
#define TMP ".tmp"
#endif

#define MAXSUFFIXLEN 4

/* parser */
#ifndef FPARSER    
#define FPARSER PARSER
#endif


/* command to clobber tempfiles after use */

#ifndef ZAPFILE
#define ZAPFILE(x) unlink(x)
#endif

#ifndef FILENAMEMAX
#define FILENAMEMAX 14
#endif

#define SIGNIFICANT (FILENAMEMAX-MAXSUFFIXLEN)

/*
 *	globals
 */

/* Outputfilenames */

GLOBAL char MODULE[FILENAMEMAX];
GLOBAL char FM2[FILENAMEMAX];
GLOBAL char FDEF[FILENAMEMAX];
GLOBAL char FOUT[FILENAMEMAX];
GLOBAL char FDATA[FILENAMEMAX];
GLOBAL char FACTION[FILENAMEMAX];
GLOBAL char FLOCAL[FILENAMEMAX];
GLOBAL char FTEMP[FILENAMEMAX];
GLOBAL char FTAB[5*FILENAMEMAX];

/* I/O descriptors */

/* output files */
GLOBAL FILE * fm2;		/* implementation module */
GLOBAL FILE * fdef;		/* definition module */
GLOBAL FILE * fout;             /* verbose file */  
GLOBAL FILE * ftab;		 

/* tempfiles to collect output */
GLOBAL FILE * fdata;		/* data file (parsertables) */
GLOBAL FILE * flocal;		/* local constants of implemantation module */
GLOBAL FILE * faction;          /* file for saving actions */

/* input files */
GLOBAL FILE * finput;           /* grammar */
GLOBAL FILE * fparser;		/* parser skeleton */

/* tempfile to pass 2 */
GLOBAL FILE * ftemp;           

/* token information */
GLOBAL int ntokens;    		/* number of tokens */
GLOBAL struct toksymb tokset[NTERMS];
GLOBAL int toklev[NTERMS];
GLOBAL int extval;
GLOBAL int *expects;

/* Access macros to expects */
/* SetSz = size of one errorset in bytes */
/* Set(s)= address of s'th set	         */
#ifdef WORD32
#define SetSz (((ntokens+1)%32?1+(ntokens+1)/32:(ntokens+1)/32)*sizeof(int))
#define Set(s)	 (expects+s*(SetSz/sizeof(int)))
#define SetBit(s,i) *(Set(s)+i/32)|=1<<(037-i%32)
#define Bit(s,i) *(Set(s)+i/32)&1<<(037-i%32)
#endif

/* nonterminal information */

GLOBAL int nnonter INIT(-1);
GLOBAL struct ntsymb nontrst[NNONTERM];

/* grammar rule information */

GLOBAL int nprod INIT(1);      /* number of productions */
GLOBAL int *prdptr[NPROD];     /* pointers to descriptions of productions */
GLOBAL int levprd[NPROD] ;     /* precedence levels for the productions */

/* state information */

GLOBAL int defact[NSTATES];    /* the default actions of states */

/* storage for productions */

GLOBAL int mem0[MEMSIZE] ; /* production storage */
GLOBAL int *mem INIT(mem0);

/* lookahead computations */

GLOBAL int tbitset;
GLOBAL struct looksets lkst[LSETSIZE];
GLOBAL int nolook; /* flag to suppress lookahead computations */

/* working set computations */

GLOBAL struct wset wsets[WSETSIZE];
GLOBAL struct wset *cwp;

/* state information */

GLOBAL int nstate;         /* number of states */
GLOBAL struct item *pstate[NSTATES+2]; /* pointers to the descriptions of the states */
GLOBAL int tystate[NSTATES];   /* contains type information about the states */
GLOBAL int indgo[NSTATES];             /* index to the stored goto table */
GLOBAL int tstates[NTERMS]; /* states generated by terminal gotos */
GLOBAL int ntstates[NNONTERM]; /* states generated by nonterminal gotos */
GLOBAL int mstates[NSTATES]; /* chain of overflows of term/nonterm generation lists  */

/* storage for the actions in the parser */

GLOBAL int amem[ACTSIZE];      /* action table storage */
GLOBAL int *memp INIT(amem);       /* next free action table position */

/* other storage areas */

GLOBAL int temp1[TEMPSIZE]; /* temporary storage, indexed by terms + ntokens or states */
GLOBAL int lineno INIT(1); /* current input line number */

/* accumulators for statistics information */

GLOBAL int zzgoent;
GLOBAL int zzgobest;
GLOBAL int zzacent;
GLOBAL int zzexcp;
GLOBAL int zzclose;
GLOBAL int zzsrconf;
GLOBAL int zzrrconf;

GLOBAL char initproc[40] INIT('\0');
GLOBAL char initmodule[20] INIT('\0');
#define VERSION "myacc 2.0 -- (C) by ws 3/88 --"

/*
 * Save filehandling macros 
 */

#define ffclose(fp) if(fp) {fclose(fp); fp = (FILE *) 0;} else\
	fprintf(stderr,\
	"warning: try to close a nonexisting stream: %s\n","fp")
#define ffopen(fp,fname,fmode) \
if (fp) \
	fprintf(stderr, \
     	       "warning: stream %s not (re)opened since it's not null\n","fp");\
else\
	if (!(fp = fopen(fname,fmode))) \
			error("cannot open: %s\n",fname);\
	else /*void*/

#undef	GLOBAL
#undef	INIT
#define	DEFS_H
#endif
