#include "mdefs.h"

/*
 *	local definitions
 */

# define a amem
# define pa indgo
# define yypact	temp1
# define greed tystate

# define NOMORE	-1000

/*
 *	locals
 */

static int	*ggreed	= lkst[0].lset;
static int	*pgo = wsets[0].ws.lset;
static int	*yypgo = &nontrst[0].tvalue;
static int	maxspr = 0;  /*	maximum	spread of any entry */
static int	maxoff = 0;  /*	maximum	offset into a array */
static int	*pmem =	mem0;
static int	*maxa;

/*
 *	functions
 */

aoutput()
{
	/* write out the optimized parser */

	wdef(flocal,"YYLAST",maxa - a + 1);  

	arout( "yyact",	a, (maxa - a) +	1 );
	arout( "yypact", pa, nstate );
	arout( "yypgo",	pgo, nnonter + 1 );

}

/* read	the arrays from	tempfile and set parameters */

callopt()

{       register i, *p,	j, k, *q;

	ffopen(ftemp,FTEMP,"r");
	pgo[0] = 0;
	yypact[0] = 0;
	nstate = 0;
	nnonter	= 0;
	for (; ; ) {
		int x;
		switch ( gtnm()	) {

		case '\n':
			yypact[++nstate] = (--pmem) - mem0;

		case ',':
			continue;

		case '$':
			break;

		default:
			error( "bad tempfile reading %d",x );
		}
		break;
	}

	yypact[nstate] = yypgo[0] = (--pmem) - mem0;

	for (; ; ) 
	{ 	int x;
		switch (x= gtnm()) {
		case '\n':
			yypgo[++nnonter] = pmem	- mem0;
		case '\r':
		case ',' :
			continue;

		case -1: /* EOF	*/
			break;

		default:
			error( "bad tempfile reading %d",x );
		}
		break;
	}

	yypgo[nnonter--] = (--pmem) - mem0;

	for ( i	= 0; i < nstate; ++i ) {

		k = 32000;
		j = 0;
		q = mem0 + yypact[i+1];
		for ( p	= mem0 + yypact[i]; p <	q ; p += 2 ) {
			if ( *p	> j )
				j = *p;
			if ( *p	< k )
				k = *p;
		}
		if ( k <= j ) {
			/* nontrivial situation	*/
			/* temporarily,	kill this for compatibility
				j -= k;	 j is now the range */
			if ( k > maxoff	)
				maxoff = k;
		}
		greed[i] = (yypact[i+1]	- yypact[i]) + 2 * j;
		if ( j > maxspr	)
			maxspr = j;
	}

	/* initialize ggreed table */

	for ( i	= 1; i <= nnonter; ++i ) {
		ggreed[i] = 1;
		j = 0;
		/* minimum entry index is always 0 */
		q = mem0 + yypgo[i+1] -	1;
		for ( p	= mem0 + yypgo[i]; p < q ; p +=	2 ) {
			ggreed[i] += 2;
			if ( *p	> j )
				j = *p;
		}
		ggreed[i] = ggreed[i] +	2 * j;
		if ( j > maxoff	)
			maxoff = j;
	}

	/* now,	prepare	to put the shift actions into the a array */

	for ( i	= 0; i < ACTSIZE; ++i )
		a[i] = 0;
	maxa = a;

	for ( i	= 0; i < nstate; ++i )
	{
#ifdef DBG
		if ( greed[i] == 0)
			fprintf(stderr, "State %d: null\n", i );
#endif
		pa[i] =	YYFLAG1;
	}
	while (	(i = nxti()) !=	NOMORE ) {
		if ( i >= 0 )
			stin(i);
		else
			gin(-i);

	}

#ifdef DBG 	/* print a array */
	fprintf(stderr,"callopt() \n");
	for ( p	= a; p <= maxa;	p += 10) 
	{	fprintf( stderr, "%4d  ", p - a );
		for ( i	= 0; i < 10; ++i )
			fprintf( stderr, "%4d  ", p[i] );
		fprintf( stderr, "\n" );
	}
#endif

	aoutput();	/*output the optimized parser */
	osummary();
	ffclose(ftemp);
}


gin(i)
{

	register *p, *r, *s, *q1, *q2;

	/* enter gotos on nonterminal i	into array a */

	ggreed[i] = 0;

	q2 = mem0 + yypgo[i+1] - 1;
	q1 = mem0 + yypgo[i];

	/* now,	find a place for it */

	for ( p	= a; p < &a[ACTSIZE]; ++p ) {
		if ( *p	)
			continue;
		for ( r	= q1; r	< q2; r	+= 2 ) {
			s = p +	*r + 1;
			if ( *s	)
				goto nextgp;
			if ( s > maxa )	{
				if ( (maxa = s)	> &a[ACTSIZE] )
					error( "a array overflow" );
			}
		}
		/* we have found a spot	*/

		*p = *q2;
		if ( p > maxa )	{
			if ( (maxa = p)	> &a[ACTSIZE] )
				error( "a array overflow" );
		}
		for ( r	= q1; r	< q2; r	+= 2 ) {
			s = p +	*r + 1;
			*s = r[1];
		}

		pgo[i] = p - a;
#ifdef DBG
		fprintf(stderr,"Nonterminal %d, entry at %d\n", i, pgo[i]);
#endif
		goto nextgi;

nextgp:
		;
	}

	error( "cannot place goto %d\n", i );

nextgi:
	;
}


/* read	and convert an integer from the	standard input */
/* return the terminating character */
/* blanks, tabs, and newlines are ignored */
gtnm()
{ 	register s, val, c;

	s = 1;
	val = 0;

	while ((c = getc(ftemp)) != EOF)
	{ 	if (isdigit(c)) 
			val = val * 10 + c - '0';
		else if ( c == '-' )
			s = -1;
		else if	( c == '\r')
			continue;
		else
			break;
	}
	*pmem++	= s * val;
	if ( pmem > &mem0[MEMSIZE] )
		error( "out of space" );
	return(	c );

}


nxti()
{
	/* finds the next i */
	register i, max, maxi;

	max = 0;

	for ( i	= 1; i <= nnonter; ++i )
		if ( ggreed[i] >= max )	{
			max = ggreed[i];
			maxi = -i;
		}

	for ( i	= 0; i < nstate; ++i )
		if ( greed[i] >= max ) {
			max = greed[i];
			maxi = i;
		}

#ifdef DBG
	fprintf(stderr, "nxti = %d, max = %d\n", maxi, max );
#endif
	if ( max == 0 )
		return(	NOMORE );
	else
		return(	maxi );
}


/*
 * Write summary.
 */

osummary()

{
	register int i, *p;

	if (!fout)
		return; 
	i = 0;
	for (p = maxa; p >= a; --p) {

		if (*p == 0)
			++i;
	}
	fprintf(fout, "Optimizer space used: input %d/%d, output %d/%d\n",
	       pmem - mem0 + 1,	MEMSIZE, maxa -	a + 1, ACTSIZE);
	fprintf(fout, "%d table entries, %d zero\n", (maxa -	a) + 1,	i);
	fprintf(fout, "maximum spread: %d, maximum offset: %d\n", maxspr,
	     maxoff);
	ffclose(fout);
}


stin(i)
{
	register *r, *s, n, flag, j, *q1, *q2;

	greed[i] = 0;

	/* enter state i into the a array */

	q2 = mem0 + yypact[i+1];
	q1 = mem0 + yypact[i];
	/* find	an acceptable place */

	for ( n	= -maxoff; n < ACTSIZE;	++n ) {

		flag = 0;
		for ( r	= q1; r	< q2; r	+= 2 ) {
			if ( (s	= *r + n + a ) < a )
				goto nextn;
			if ( *s	== 0 )
				++flag;
			else if	( *s !=	r[1] )
				goto nextn;
		}

		/* check that the position equals another only if the states are identical */

		for ( j	= 0; j < nstate; ++j ) {
			if ( pa[j] == n	) {
				if ( flag )
					goto nextn;  /*	we have	some disagreement */
				if ( yypact[j+1] + yypact[i] ==	yypact[j] +
				    yypact[i+1]	) {
					/* states are equal */
					pa[i] =	n;
#ifdef DBG
					fprintf(stderr, "State %d: entry at\
				 			%d equals state %d\n",
							i, n, j );
#endif
					return;
				}
				goto nextn;  /*	we have	some disagreement */
			}
		}

		for ( r	= q1; r	< q2; r	+= 2 ) {
			if ( (s	= *r + n + a ) >= &a[ACTSIZE] )
				error( "out of space in optimizer a array" );
			if ( s > maxa )
				maxa = s;
			if ( *s	!= 0 &&	*s != r[1] )
				error( "clobber of a array, pos'n %d, by %d",
				     s - a, r[1] );
			*s = r[1];
		}
		pa[i] =	n;
#ifdef DBG
		fprintf( fm2, "State %d: entry at %d\n", i, pa[i] );
#endif
		return;
nextn:
		;
	}

	error( "Error; failure to place state %d\n", i );
}


